import 'package:chhota_stocks_flutter/src/feature/commonWidget/common_widgets.dart';
import 'package:chhota_stocks_flutter/src/feature/createTransaction/bloc/create_txn_cubit.dart';
import 'package:chhota_stocks_flutter/src/feature/createTransaction/model/create_txn_type.dart';
import 'package:chhota_stocks_flutter/src/feature/createTransaction/ui/txn_loader.dart';
import 'package:flutter/material.dart';
import 'package:flutter_bloc/flutter_bloc.dart';
import 'package:scgateway_flutter_plugin/scgateway_flutter_plugin.dart';

class SIPButton extends StatelessWidget {
  final String scid;
  const SIPButton({Key? key, required this.scid}) : super(key: key);
  @override
  Widget build(BuildContext context) {
    return MultiBlocProvider(
      providers: [
        BlocProvider<CreateTxnCubit>(create: (_) => CreateTxnCubit()),
      ],
      child: _SIPButton(scid: scid),
    );
  }
}

class _SIPButton extends StatelessWidget {
  final String scid;
  const _SIPButton({Key? key, required this.scid}) : super(key: key);
  @override
  Widget build(BuildContext context) {
    return BlocConsumer<CreateTxnCubit, CreateTxnState>(
      listener: (context, state) {
        if (state is CreateTxnSuccess && state.txnData.transactionId != null) {
          ScgatewayFlutterPlugin.triggerGatewayTransaction(
              state.txnData.transactionId!)
              .then((data) async {
            Navigator.push(
                context,
                MaterialPageRoute(
                    builder: (context) => TransactionLoader(
                      data: data,
                    )));
          });
        } else if (state is CreateTxnError) {
          // Fluttertoast.showToast(msg: state.errorMsg);
        }
      },
      builder: (context, state) {
        if(state is CreateTxnLoading){
          return Column(
            children: const [
              ShimmerLoader(
                height: 50,

              ),
              Divider(color: Color(0xFFdde0e4),),
            ],
          );
        }
        return InkWell(
          onTap: () => state is CreateTxnLoading
              ? null
              : BlocProvider.of<CreateTxnCubit>(context)
              .createTransaction(scid: scid,createTransactionType: CreateTransactionType.SIP),
          child:  Column(
            crossAxisAlignment: CrossAxisAlignment.start,
            children: [
              const SizedBox(height: 12,),
              Row(
                children: const [
                  Icon(Icons.sip,size: 20,),
                  SizedBox(width: 12.0,),
                  Text("Start SIP"),
                ],),

              const SizedBox(height: 12,),

              const Divider(color: Color(0xFFdde0e4),),
            ],
          )


        );



      },
    );
  }
}
